class Counter {
  constructor() { this.value = 0; }
  
  increment() {
    console.log('incrementing...');
    this.value += 1;
    return this;
  }                          
  
  decrement() {
    console.log('decrementing...');
    this.value -= 1;
    return this;
  }
  
  get count() { return this.value; } 
}

const counter = new Counter();

counter.increment().increment().decrement().increment();
//above is eager evaluation
console.log(counter.count);

console.log("...let's get lazy...");

const proxy = new Proxy(counter, {
  actions: [],
  get: function(target, property, receiver) {
    if(property === 'result') {
      this.actions.forEach(action => target[action]());
      return target.count;
    }
    
    this.actions.push(property);
    return receiver;
  }
});

proxy.increment.increment.decrement.increment;

console.log('calls did not happen yet');

console.log(proxy.result);

